#include <bits/stdc++.h>
#include "testlib.h"
 
using namespace std;

vector<pair<int, int>> obfuscate(int n, vector<pair<int, int>> edges) {  // edges are 0-indexed
    // vector<int> mapping(n);
    // iota(mapping.begin(), mapping.end(), 1);
    // shuffle(mapping.begin(), mapping.end());

    shuffle(edges.begin(), edges.end());
    for (auto& [u, v] : edges) {
        if (rnd.next(2)) {
            swap(u, v);
        }
        // u = mapping[u];
        // v = mapping[v];
    }
    return edges;
}

void print(int n, const vector<pair<int, int>>& edges) {
    cout << n << " " << edges.size() << endl;
    for (const auto& [u, v] : edges) {
        cout << u << " " << v << endl;
    }
}
 
int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int n = opt<int>(1);
    vector<int> perm(n - 2);
    for (int i = 0; i < n - 2; ++i) {
        perm[i] = i + 2;
    }
    shuffle(perm.begin(), perm.end());
    
    vector<pair<int, int>> edges;
    edges.emplace_back(1, perm[0]);
    for (int i = 1; i <= n - 5; ++i) {
        edges.emplace_back(perm[i - 1], perm[i]);
    }
    edges.emplace_back(perm[n - 5], perm[n - 4]);
    edges.emplace_back(perm[n - 4], perm[n - 3]);
    edges.emplace_back(perm[n - 3], perm[n - 5]);
    edges.emplace_back(1, n);

    edges = obfuscate(n, edges);
    print(n, edges);
}
