#include <bits/stdc++.h>
#include "testlib.h"
 
using namespace std;

vector<pair<int, int>> obfuscate(int n, vector<pair<int, int>> edges) {  // edges are 0-indexed
    // vector<int> mapping(n);
    // iota(mapping.begin(), mapping.end(), 1);
    // shuffle(mapping.begin(), mapping.end());

    shuffle(edges.begin(), edges.end());
    for (auto& [u, v] : edges) {
        if (rnd.next(2)) {
            swap(u, v);
        }
        // u = mapping[u];
        // v = mapping[v];
    }
    return edges;
}

void print(int n, const vector<pair<int, int>>& edges) {
    cout << n << " " << edges.size() << endl;
    for (const auto& [u, v] : edges) {
        cout << u << " " << v << endl;
    }
}
 
int main(int argc, char *argv[]) {
    registerGen(argc, argv, 1);

    int n = opt<int>(1);
    vector<pair<int, int>> extra_edges;
    for (int i = 0; i < n; ++i) {
        for (int j = i + 2; j < n; ++j) {
            extra_edges.emplace_back(i + 1, j + 1);
        }
    }
    extra_edges = obfuscate(n, extra_edges);

    vector<pair<int, int>> edges;
    for (int i = 1; i < n; ++i) {
        edges.emplace_back(i, i + 1);
    }
    for (auto p : extra_edges) {
        edges.push_back(p);
    }
    print(n, edges);
}
