#include <bits/stdc++.h>

using namespace std;

int main () {
    ios::sync_with_stdio(false);
    cin.tie(0);

    int n, m;
    cin >> n >> m;

    vector<vector<char>> mat(n, vector<char>(n, false));
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        mat[u][v] = mat[v][u] = 1;
    }
    
    vector<int> perm(n);
    iota(perm.begin(), perm.end(), 0);
    do {
        if (perm[0] != 0) {
            next_permutation(perm.begin(), perm.end());
            continue;
        }
        bool good = true;
        for (size_t i = 1; i < perm.size(); ++i) {
            if (!mat[perm[i - 1]][perm[i]]) {
                good = false;
                break;
            }
            if (perm[i] == n - 1) {
                perm.resize(i + 1);
                break;
            }
        }
        if (good) {
            break;
        }
        next_permutation(perm.begin(), perm.end());
    } while (!is_sorted(perm.begin(), perm.end()));

    vector<int> path = perm;
    cout << (path.size() + 1) % 2 << " " << path.size() << endl;
    cout << path[0] + 1;
    for (size_t i = 1; i < path.size(); ++i) {
        cout << (i % 2 ? " + " : " - ") << path[i] + 1;
    }
    cout << endl;
    
    return 0;
}
