#include <bits/stdc++.h>

using namespace std;

bool dfs(int cur, int par, int n, vector<vector<int>>& g, vector<int>& path) {
    path.push_back(cur);
    if (cur == n) {
        return true;
    }
    for (int nxt : g[cur]) {
        if (nxt != par) {
            if (dfs(nxt, cur, n, g, path)) {
                return true;
            }
        }
    }
    path.pop_back();
    return false;
}

int main () {
    ios::sync_with_stdio(false);
    cin.tie(0);

    int n, m;
    cin >> n >> m;

    vector<vector<int>> g(n);
    for (int i = 0; i < m; ++i) {
        int u, v;
        cin >> u >> v;
        --u; --v;
        g[u].push_back(v);
        g[v].push_back(u);
    }
    vector<int> path;
    dfs(0, -1, n - 1, g, path);
    
    cout << (path.size() + 1) % 2 << " " << path.size() << endl;
    cout << path[0] + 1;
    for (size_t i = 1; i < path.size(); ++i) {
        cout << (i % 2 ? " + " : " - ") << path[i] + 1;
    }
    cout << endl;
    return 0;
}
